//
//		Definition of the Graphics Manager class
//
//
#ifndef THE_GRAPHICS_MANAGER_H
#define THE_GRAPHICS_MANAGER_H

#include "ldwImage.h"
#include "ldwTiledBackground.h"
//
//	resource #'s from Plant Tycoon pocket pc version
//

//

enum ImageId
{
	eImage,
	eImageStrip,
	eImageGrid,

	eNoGraphic = 0,

	eSplashBG,
	eSplashBG2,
	eSplashBG3,
	eCollectingBG,
	eEmptyButton,
	eLoadingBG,

	eLogo,	
	eLdwLogo,	
	eBfgLogo,
	eIntro1BG,
	eIntro2BG,
	eMenuBG,
	eGameWinBG,
	eMainBG,
	eHandCursorOpen,
	eHandCursor,
	eMainCollectButton,
	eSnapshotButton,
	eCurrentPlayerButton,
	eChangePlayerButton,
	eQuitButton,
	eStartOverButton,
	ePlayButton,
	eOptionsButton,
	eHelpButton,

	eSeedBG,
	eShopBG,					
	eSellBG,			
	eSnapshot1BG,
	eSnapshot2BG,
	eSnapshot3BG,
	eDialogTiles,

	eSellButton,
	eLitButton,

			
	eBuyButton,		
	eCheckMark,		
	eTrashBin,

	eFallingDirt,		
	eFallingFood,		
	eDustParticle1,
	eFallingWater,			
	eFlies,									
	eGoldPot,			
	eHealthMeter,									
						
	ePriceTag,		
	eSeeds,					
	eSoil,			
	eSoilBags,			
	eSoldSign,		
	eSpraying,
	eSprayingRed,		
	eSprayingYellow,		
	eSprayingBlue,		
	eSprayingPurple,				
	eTestPlant,
	eCactus1Plant,
	eCowboyCactus,
	eFlower1Plant,
	eIvy1Plant,
	eBallCactus,
	eBallCactus2,
	eBananaPlant,
	eLemonGrass,
	eLemonTree,
	eFern,
	eWillowTree,
	eBananaTree,
	eDieffenbachia,
	eBambooTree,
	eCaladiumPlant,
	eBonsaiTree,
	eOakTree,
	eOrchid,
	eAnanas,
	eTigerFern,
	eBopPlant,
	ePitcherPlant,
	eUnknownPlant,
	eFlowers56x56,
	eFlowers64x64,	
	eFruit,
	eTestPlantMask,
	eCactus1PlantMask,
	eCowboyCactusMask,
	eFlower1PlantMask,
	eIvy1PlantMask,
	eBallCactusMask,
	eBallCactus2Mask,
	eBananaPlantMask,
	eLemonGrassMask,
	eLemonTreeMask,
	eFernMask,
	eWillowTreeMask,
	eBananaTreeMask,
	eDieffenbachiaMask,
	eBambooTreeMask,
	eCaladiumPlantMask,
	eBonsaiTreeMask,
	eOakTreeMask,
	eOrchidMask,
	eAnanasMask,
	eTigerFernMask,
	eBopPlantMask,
	ePitcherPlantMask,
	eFlowers56x56Mask,
	eFlowers64x64Mask,	
	eFruitMask,
	eBench1,
	eBirdhouse1,
	eTurtle1,
	eGreenhouse2,
	eWaterBarrel1,
	eBushRt2,
	eBushRt3,
	eBugZapper1,
	eWeathervane1,
	eCherub1,
	eSundial1,
	eOwl1,
	eBuddha1,
	eGate3,
	eFence3,
	eGate3BG,
	eFence3BG,
	eFence1BG,
	eFountainBGOverlay,
	eBarrelBase1,
	eSpikeyNEBush1,
	eNurseryUI,
	eNurseryBorder,
	

	eAnanasDead,
	eBallCactus2Dead,
	eBallCactusDead,
	eBambooTreeDead,
    eBananaPlantDead,
	eBananaTreeDead,
	eBonsaiTreeDead,
	eCactus1PlantDead,
	eCaladiumPlantDead,
	eCowboyCactusDead,
	eDieffenbachiaDead,
	eFernDead,
	eFlower1PlantDead,
	eIvy1PlantDead,
	eLemonGrassDead,
	eLemonTreeDead,
	eOakTreeDead,
	eOrchidDead,
	eTestPlantDead,
	eWillowTreeDead,
	eTigerFernDead,
	eBopPlantDead,
	ePitcherPlantDead,
	
	eWaterBuckets,	
	eWaterMeter,		
	ePot1,
	eSmallBugs,
	eBeamOfLight,
	eFocusCircle,
	eScissors,
	ePollinating,
	eNet,
	eFemaleHeads,
	eMaleHeads,
	eTBubbleL,
	eTBubbleR,
	eFemaleActionsSheet,
	eMaleActionsSheet,
	eWhiteSparkle1, 
	eWhiteSparkleBig,
	eSparkleYellow1,
	eBlurrySparkle,	
	eSharpSparkle,
	eBugShadow,
	ePeepShadow,
	eShopOrnaments,	
	eShopTools,		
	eShopChems,	
	eForSaleButton,
	eSeedBoxUpgrade,
	eIdeas,
	eBushRt,
	eFence1,
	eFence2,
	eCenterFountain,
	eGate1,
	eGate2,
	eCashReg1,
	eCashReg2,
	eSign1,
	eSign2,
	eGreenhouse1,
	ePlantTablesBG1,
	ePlantTablesFG1,
	eThoughtBubLow,
	eCollectionJars,
	eSingleTable1,
	eWidePTButton,
	ePurplePTButton,
	eHose,	
	eSpiderWeb,
	eBug_Case,
	eWheel_Barrow,
	ePointyBushE1,
	eBushDetailE2,
	eWVaneBushW1,
	eBushTable1,	
	eWaterfall2,
	eWaterfallFoam,
	eWaterSpray,
	ePhotoMsg,
	eCollectionJarLeaves,
	eRockCenter,
	eBarrelBush,
	eBirdhouseAnimStrip,
	eTurtleSquirtAnimStrip,
	eCollectionJarLeafGrid,

	eArrowUp,
	eArrowDown,

	eImageCount

	,WOMAN1_SE1 = eImageCount                      
	,WOMAN1_SE2                      
	,WOMAN1_SW1                      
	,WOMAN1_SW2                      
	,WOMAN1_NW1                      
	,WOMAN1_NW2                      
	,WOMAN1_NE1                      
	,WOMAN1_NE2                      
	,WOMAN2_SE1                      
	,WOMAN2_SE2                      
	,WOMAN2_SW1                      
	,WOMAN2_SW2                      
	,WOMAN2_NW1                      
	,WOMAN2_NW2                      
	,WOMAN2_NE1                      
	,WOMAN2_NE2                      
	,MAN1_SE1                        
	,MAN1_SE2                        
	,MAN1_SW1                        
	,MAN1_SW2                        
	,MAN1_NW1                        
	,MAN1_NW2                        
	,MAN1_NE1                        
	,MAN1_NE2                        
	,MAN2_SE1                        
	,MAN2_SE2                        
	,MAN2_SW1                        
	,MAN2_SW2                        
	,MAN2_NW1                        
	,MAN2_NW2                        
	,MAN2_NE1                        
	,MAN2_NE2                        
	,SOILBAG1                        
	,SOILBAG2                        
	,SOILBAG3                        
	,SOILPILE1                       
	,SOILPILE2                       
	,SOILPILE3                       
	,WATERBUCKET1                    
	,WATERBUCKET2                    
	,WATERBUCKET3                    
	,BUCKETINUSE1                    
	,BUCKETINUSE2                    
	,BUCKETINUSE3                    
	,FERT1                           
	,FERT2                           
	,FERT3                           
	,FERTINUSE1                      
	,FERTINUSE2                      
	,FERTINUSE3                      
	,MEDS1                           
	,MEDS2                           
	,MEDS3                           
	,MEDSINUSE1                      
	,MEDSINUSE2                      
	,MEDSINUSE3                      
	,MINIFOUNT1                      
	,MINIFOUNT2                      
	,MINIFOUNT3                      
	,FOUNT1                          
	,FOUNT2                          
	,FOUNT3                          
	,PLANT01                         
	,PLANT02                         
	,PLANT03                         
	,PLANT04                         
	,PLANT05                         
	,PLANT06                         
	,PLANT07                         
	,PLANT08                         
	,PLANT09                         
	,PLANT10                         
	,PLANT11                         
	,PLANT12                         
	,PLANT13                         
	,PLANT14                         
	,PLANT15                         
	,PLANT16                         
	,PLANT17                         
	,RAREPLANT1                      
	,RAREPLANT2                      
	,RAREPLANT3                      
	,RAREPLANT4                      
	,RAREPLANT5                      
	,DEAD_FLOWER                     
	,DEAD_TREE                       
	,DEAD_CAC                        
	,FLOWER01                        
	,FLOWER02                        
	,FLOWER03                        
	,FLOWER04                        
	,FLOWER05                        
	,FLOWER06                        
	,FLOWER07                        
	,FLOWER08                        
	,FLOWER09                        
	,FLOWER10                        
	,FLOWER11                        
	,FLOWER12                        
	,FLOWER13                        
	,FLOWER14                        
	,FLOWER15                        
	,FLOWER16                        
	,FLOWER17                        
	,FLOWER18                        
	,FLOWER19                        
	,FLOWER20                        
	,FLOWER21                        
	,RAREFLOWER22                    
	,RAREFLOWER23                    
	,RAREFLOWER24                    
	,RAREFLOWER25                    
	,RAREFLOWER26                    
	,SEED01                          
	,SEED02                          
	,SEED03                          
	,SEED04                          
	,SEED05                          
	,SEED06                          
	,SEED07                          
	,SEED08                          
	,SEED09                          
	,SEED10                          
	,SEED11                          
	,SEED12                          
	,SEED13                          
	,SEED14                          
	,SEED15                          
	,SEED16                          
	,SEED17                          
	,SEED18                          
	,SEED19                          
	,SEED20                          
	,SEED21                          
	,SEED22                          
	,SEED23                          
	,SEED24                          
	,SEED25                          
	,SEED26                          
	,SEED27                          
	,SEED28                          
	,SEED29                          
	,SEED30                          
	,SEED31                          
	,SEED32                          
	,SEED33                          
	,SEED34                          
	,SEED35                          
	,SEED36                          
	,SEED37                          
	,SEED38                          
	,SEED39                          
	,SEED40                          
	,SEED41                          
	,SEED42                          
	,SEED43                          
	,SEED44                          
	,SEED45                          
	,SEED46                          
	,SEED47                          
	,SEED48                          
	,SEED49                          
	,SEED50                          
	,SEED51                          
	,SEED52                          
	,SEED53                          
	,SEED54                          
	,SEED55                          
	,SEED56                          
	,SEED57                          
	,SEED58                          
	,SEED59                          
	,SEED60                          
	,SEED61                          
	,SEED62                          
	,SEED63                          
	,SEED64                          
	,SEED65                          
	,SEED66                          
	,SEED67                          
	,SEED68                          
	,SEED69                          
	,SEED70                          
	,SEED71                          
	,SEED72                          
	,SEED73                          
	,SEED74                          
	,SEED75                          
	,SEED76                          
	,SEED77                          
	,SEED78                          
	,SEED79                          
	,SEED80                          
	,SEED81                          
	,SEED82                          
	,SEED83                          
	,SEED84                          
	,SEED85                          
	,SEED86                          
	,SEED87                          
	,SEED88                          

	,eImageIdEnd
};

const int cPlantBase  = 0;
const int cFlowerBase = 0;

const int cNextToolOffset = (WATERBUCKET1 - SOILBAG1);

class theGraphicsManagerImpl;
class ldwGameWindow;

class theGraphicsManager
{
public:

	static theGraphicsManager *Get();
	static void Destroy();

	ldwImage      *GetImage(ImageId imageId);
	ldwImageStrip *GetImageStrip(ImageId imageId);
	ldwImageGrid  *GetImageGrid(ImageId imageId);

	int  GetImageType(ImageId imageId);
	int  GetCellCount(ImageId imageId);

	void ReleaseImage(ImageId imageId,bool purge = false);

	void Draw(ImageId imageId);

	void Draw(ImageId imageId,int x,int y,float alpha = 1.0f,int scale = 100);
//	void Draw(ImageId imageId,int x,int y,bool scaleXY);

	void DrawCell(ImageId imageId, int cell);

	void DrawCell(ImageId imageId, int cell, int x, int y,float alpha = 1.0f,int scale = 100);
//	void DrawCell(ImageId imageId, int cell, int x, int y,bool scaleXY);

	//void DrawTools();
//	void DrawPlant(int xPos, int yPos, int whichPlant);

	static int XlateX(int x);
	static int XlateY(int y);
	static int RevXlateX(int x);
	static int RevXlateY(int y);

	static int XlateWidth(int width);
	static int XlateHeight(int height);

protected:
	
	static theGraphicsManager *mInstance;

	theGraphicsManager();
	~theGraphicsManager();

	theGraphicsManagerImpl *mGraphicsManager;

	ldwGameWindow *mGameWindow;
};
#endif