//
//		Definition of the seed game class
//
#ifndef THE_SEED_SCENE_H
#define THE_SEED_SCENE_H

#include "theGameState.h"
#include "theHomingClass.h"
#include "ldwScene.h"
#include "ldwImage.h"

class theSoundManager;
class theGraphicsManager;
class thePlantManager;
class theStringManager;
class ldwHintControl; 
class ldwGameWindow;
class ldwTextControl;
class theToolTray;

const int theSeedScene_c_iMaxSaleNotifications = 8;
class theSeedScene : public ldwScene
{
public:

	theSeedScene();
	~theSeedScene();
	
	bool HandleKey(int messageId,int keyCode,int character);
	bool HandleMouse(int messageId,ldwPoint location);
	bool HandleMessage(int messageId,long data);

protected:

	void Activate(bool active);
	void DrawScene();
	void UpdateScene();

private:

	bool LDWPointInRect(int x,int y,int left,int top,int width,int height);

	const bool HandleMouseUpEvent(const ldwPoint location);
	const bool HandleMouseDownEvent(const ldwPoint location);

	void PutSeedInSeedTray(const int row, const int column);
	void PutSeedInSeedBox(const int row, const int column);
	void ReturnSeed(void);
	void CheckMouseOver(int x,int y);
	void DrawSeedLicense (SeedType * whichSeed);
	void DrawPlantSkin (int xPos, int yPos, SkinType * whichSkin);
	bool SeedTrashAlert();
	bool TrashCan(int x, int y);

	bool ForwardWaitingMessage(StringId whichMessage);

	ldwHintControl *seedBoxMouseover1;
	ldwHintControl *seedBoxMouseover2;

	ldwTextControl *seedsLabel;
	ldwTextControl *toolsLabel;
	ldwTextControl *trashLabel;

	bool mouseIsDown;
	
	ldwImage *hand;
	ldwImage *handOpen;
	ldwImage *focusCircle;

	theGameState       *gs;
	theGraphicsManager *gm;
	thePlantManager    *pm;
	theSoundManager    *soundMgr;
	theStringManager   *stringMgr;
	theHomingClass		*seedHomer;
	ldwGameWindow		*gameWindow;

	int 		FOCUS;
	ldwPoint 	tempSeedPos;
	ldwPoint	homingSeedPos;

	typedef struct
	{
		int				m_iPrice;
	}
	SSaleNotification;

	SSaleNotification	m_SaleNotificationQueue[theSeedScene_c_iMaxSaleNotifications];
	int					m_iSaleNotificationQueueHead;
	int					m_iSaleNotificationQueueTail;
	ldwUINT32			m_uiSaleNotificationTimer;
};
#endif