//
//		Definition of the sell scene class
//
#ifndef THE_SELL_SCENE_H
#define THE_SELL_SCENE_H

#define cPlantOfJoyX 340
#define cPlantOfJoyY 245

#define cPlantOfLifeX 460
#define cPlantOfLifeY 245

#define cPlantOfWealthX 275
#define cPlantOfWealthY 290

#define cPlantOfKnowledgeX 525
#define cPlantOfKnowledgeY 290

#define cPlantOfIsolaX 318
#define cPlantOfIsolaY 342

#define cPlantOfFragrancesX 478
#define cPlantOfFragrancesY 342

#define cPlantOfJoyTLX 320
#define cPlantOfJoyTLY 210

#define cPlantOfLifeTLX 440
#define cPlantOfLifeTLY 210

#define cPlantOfWealthTLX 255
#define cPlantOfWealthTLY 253

#define cPlantOfKnowledgeTLX 505
#define cPlantOfKnowledgeTLY 255

#define cPlantOfIsolaTLX 300
#define cPlantOfIsolaTLY 307

#define cPlantOfFragranceTLX 457
#define cPlantOfFragranceTLY 307

#define cMPHeight 60
#define cMPWidth 40
/*
#define cPlantOfJoyX 325 //top left
#define cPlantOfJoyY 250

#define cPlantOfLifeX 475 //top right
#define cPlantOfLifeY 250

#define cPlantOfWealthX 305 //center left
#define cPlantOfWealthY 320

#define cPlantOfKnowledgeX 495 //center right
#define cPlantOfKnowledgeY 320

#define cPlantOfIsolaX 360 //bottom left
#define cPlantOfIsolaY 350

#define cPlantOfFragrancesX 435 //bottom right
#define cPlantOfFragrancesY 350
*/

const int theSellScene_c_iMaxSaleNotifications = 8;
#include "theGameState.h"

#include "ldwScene.h"
#include "ldwGameWindow.h"
#include "ldwImage.h"
#include "theShopperClass.h"
#include "ldwGameWindow.h"
#include "theHomingClass.h"

class theDealerSay;
class theGraphicsManager;
class theGameState;
class thePlantManager;
class theStringManager;
class theGameWindow;
class theSoundManager;


class theSellScene : public ldwScene
{
public:

	theSellScene();
	~theSellScene();
	
	bool HandleKey(int messageId,int keyCode,int character);
	bool HandleMouse(int messageId,ldwPoint location);
	bool HandleMessage(int messageId,long data);

protected:

	void Activate(bool active);
	void DrawScene();
	void UpdateScene();

	void DrawGardenPlants (int fGbG);

	int  ConceiveVisitors();

	int plantClickPrice;
	ldwUINT32 plantClickTimer;
	void TryToSellPlants (int numVisitors);
	void SellPlant (int x, int y, int row, int column);

	void SpawnInitialVisitors(void);
	void DrawDecals(int fGbG);
	void DrawCorrectedEmptyGoldPot(int x , int y, double scale);

	bool ForwardWaitingMessage(StringId whichMessage);
	bool LDWPointInRect(int x,int y,int left,int top,int width,int height);
private:
	typedef struct
	{
		int			m_iRow;
		int			m_iColumn;
	}
	SSaleNotification;

	SSaleNotification	m_SaleNotificationQueue[theSellScene_c_iMaxSaleNotifications];
	int					m_iSaleNotificationQueueHead;
	int					m_iSaleNotificationQueueTail;
	ldwUINT32			m_uiSaleNotificationTimer;

	//SpriteType SPRITE[maxNumSprites];

	int shopperPopulation;
	int numActiveShoppers;
	ldwUINT32 SELLTIMER;
	ldwUINT32 COMMENTCOUNT;
	ldwUINT32 GARDENADCOUNTER; 


	bool COLLMATRIX[maxNumCollGrids][maxNumCollGrids];

	bool hasDrawn;
	bool floatingWaterSpawned;

	theDealerSay       *ds;
	theGameState       *gs;
	theGraphicsManager *gm;
	thePlantManager    *pm;
	theStringManager   *stringMgr;
	theShopperClass		*shoppers;
	theContentMap      *cm;
	theSoundManager		*sm;
	ldwGameWindow	   *gw;
	theFloatingAnims   *fa;


	bool				isDragging;
	bool				plantMsg;
	bool				sundialMsg;

	ldwPoint			dragStartPos;

	theHomingClass		*potHomer;
	ldwPoint			homingPotPos;
};
#endif