//
//		Definition of the shop scene class
//
#ifndef THE_SHOP_SCENE_H
#define THE_SHOP_SCENE_H

#include "theStringManager.h"
#include "theChemicalTray.h"

#include "ldwScene.h"

class theDealerSay;
class theGameState;
class theGraphicsManager;
class theSoundManager;
//class ldwButton;
class ldwHintControl;
class ldwTextControl;

//draw dimensions
#define shopToolCellWidth					57
#define shopOrnCellWidth					57
#define shopChemCellWidth					57
#define shopSeedCellWidth					57

#define shopToolCellHeight					61
#define shopOrnCellHeight					64
#define shopChemCellHeight					62
#define shopSeedCellHeight					62




// click dimensions
#define shopToolCellClickWidth				51
#define shopToolCellClickHeight				60

#define shopOrnCellClickWidth				51
#define shopOrnCellClickHeight				61

#define shopChemCellClickWidth				45
#define shopChemCellClickHeight				52

#define shopSeedCellClickWidth				50
#define shopSeedCellClickHeight				65


//top left's
#define toolAreaTopLeftX				253
#define toolClickAreaTopLeftX			243

#define toolAreaTopLeftY				75
#define toolClickAreaTopLeftY			52




#define chemsAreaTopLeftX				618
#define chemsClickAreaTopLeftX			610

#define chemsAreaTopLeftY				 80
#define chemsClickAreaTopLeftY			 63




#define ornamentsAreaTopLeftX			253
#define ornamentsClickAreaTopLeftX		253

#define ornamentsAreaTopLeftY			302
#define ornamentsClickAreaTopLeftY		287




#define seedsForSaleAreaTopLeftX		602
#define seedsForSaleClickAreaTopLeftX	598

#define seedsForSaleAreaTopLeftY		315
#define seedsForSaleClickAreaTopLeftY	290



//click null zone dimensions
#define toolRowSpacer				     10
#define toolColumnSpacer				  6	
#define ornamentsRowSpacer				 10
#define ornamentsColumnSpacer			  8
#define chemsRowSpacer					 11
#define chemsColumnSpacer				 11
#define seedRowSpacer					 9
#define seedColumnSpacer				 10

class theShopScene : public ldwScene
{
public:

	theShopScene();
	~theShopScene();
	
	bool HandleKey(int messageId,int keyCode,int character);
	bool HandleMouse(int messageId,ldwPoint location);
	bool HandleMessage(int messageId,long data);

protected:

	void Activate(bool active);
	void DrawScene();
	void UpdateScene();

private:

	bool LDWPointInRect(int x,int y,int left,int top,int width,int height);
	void DrawShopLicense (int whichItem);
	bool AskForOK(StringId questionId);
	void BuyItem(int whichItem);
	void DrawTools();
	bool ForwardWaitingMessage(StringId whichMessage);

	
	bool hasDrawn;
	int  FOCUS;

	ldwHintControl		*hintControl[100];    

	ldwTextControl *seedsLabel;
	ldwTextControl *toolsLabel;

	ldwTextControl *toolsCategoryLabel;
	ldwTextControl *chemsLabel;
	ldwTextControl *ornamentsLabel;
	ldwTextControl *seedsCategoryLabel;

	theDealerSay  	   *ds;
	theGameState       *gs;
	theGraphicsManager *gm;
	theSoundManager    *soundMgr;
	theStringManager   *stringMgr;
	theChemicalTray *	chemicalTray;

	ldwHintControl *	m_pChemicalHintControlArray[maxChemicalTraySlots];
};
#endif