//
//	Class definition for Statistics Dialog class
//

#ifndef THE_STATISTICS_DIALOG_H
#define THE_STATISTICS_DIALOG_H

#include "ldwTiledDialog.h"

class theGameState;
class ldwImageGrid;
class theGraphicsManager;

class theStatisticsDlg : public ldwTiledDialog
{
public:

	theStatisticsDlg(int dlgCanvas);
	~theStatisticsDlg();

	int  GetResult();

	char *GetName();

	bool HandleKey(int messageId,int keyCode,int character);
	bool HandleMessage(int messageId,long data);

protected:

	enum {eDoneButtonId = 1,
	      eRefreshButtonId,
		  
		  eGlobalGameHoursControl,
		  eGlobalPointsEarnedControl,
		  eGlobalBabiesMadeControl,
		  eGlobalFoodGatheredControl,
		  eGlobalPeepsCuredControl,
		  eGlobalCrabsFoundControl,
		  eGlobalMaxPopControl,
		  eGlobalPeepsDiedControl,
		  eGlobalOldestVillagerControl,
		  eGlobalNumCrisisControl,
		  eGlobalTwinsBirthedControl,
		  eGlobalTripletsBirthedControl,
		  eGlobalPuzzlesSolvedControl
					  	
	      };

	void UpdateScene();

	void DrawNoFadeScene();
	void DrawSceneFinal();

	void GetServerStats();
	void ShowGlobalStats();

	theGameState *mGs;
	ldwImageGrid *mTiles;
	theGraphicsManager *gm;

	int mAdjustX;
	int mAdjustY;

	int mBreedsFound;

	int       mResult;
	bool      mStartRefresh;
	bool      mRefreshStats;
	ldwUINT32 mMessageTimer;
};

#endif
